# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Property do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :Location,
    :ListingKey,
    :AdditionalParcelsYN,
    :AssociationYN,
    :AttachedGarageYN,
    :BasementYN,
    :CarportYN,
    :CoolingYN,
    :CropsIncludedYN,
    :DualVariableCompensationYN,
    :ElectricOnPropertyYN,
    :FarmCreditServiceInclYN,
    :FireplaceYN,
    :GarageYN,
    :GrazingPermitsBlmYN,
    :GrazingPermitsForestServiceYN,
    :GrazingPermitsPrivateYN,
    :HabitableResidenceYN,
    :HeatingYN,
    :HomeWarrantyYN,
    :HorseYN,
    :InternetAddressDisplayYN,
    :InternetAutomatedValuationDisplayYN,
    :InternetConsumerCommentYN,
    :InternetEntireListingDisplayYN,
    :IrrigationWaterRightsYN,
    :LandLeaseYN,
    :LeaseAssignableYN,
    :LeaseConsideredYN,
    :LeaseRenewalOptionYN,
    :MobileHomeRemainsYN,
    :NewConstructionYN,
    :OpenParkingYN,
    :PoolPrivateYN,
    :PropertyAttachedYN,
    :RentControlYN,
    :SeniorCommunityYN,
    :ShowingAttendedYN,
    :SignOnPropertyYN,
    :SpaYN,
    :ViewYN,
    :WaterfrontYN,
    :AvailabilityDate,
    :CancellationDate,
    :CloseDate,
    :ContingentDate,
    :ContractStatusChangeDate,
    :ExpirationDate,
    :LandLeaseExpirationDate,
    :LeaseExpiration,
    :ListingContractDate,
    :OffMarketDate,
    :OnMarketDate,
    :PurchaseContractDate,
    :WithdrawnDate,
    :AboveGradeFinishedArea,
    :AssociationFee,
    :AssociationFee2,
    :BathroomsFull,
    :BathroomsHalf,
    :BathroomsOneQuarter,
    :BathroomsPartial,
    :BathroomsThreeQuarter,
    :BathroomsTotalInteger,
    :BedroomsPossible,
    :BedroomsTotal,
    :BelowGradeFinishedArea,
    :BuildingAreaTotal,
    :BuyerAgentKeyNumeric,
    :BuyerOfficeKeyNumeric,
    :BuyerTeamKeyNumeric,
    :CableTvExpense,
    :CapRate,
    :CarportSpaces,
    :ClosePrice,
    :CoBuyerAgentKeyNumeric,
    :CoBuyerOfficeKeyNumeric,
    :CoListAgentKeyNumeric,
    :CoListOfficeKeyNumeric,
    :ConcessionsAmount,
    :CoveredSpaces,
    :CultivatedArea,
    :CumulativeDaysOnMarket,
    :DaysOnMarket,
    :DistanceToBusNumeric,
    :DistanceToElectricNumeric,
    :DistanceToFreewayNumeric,
    :DistanceToGasNumeric,
    :DistanceToPhoneServiceNumeric,
    :DistanceToPlaceofWorshipNumeric,
    :DistanceToSchoolBusNumeric,
    :DistanceToSchoolsNumeric,
    :DistanceToSewerNumeric,
    :DistanceToShoppingNumeric,
    :DistanceToStreetNumeric,
    :DistanceToWaterNumeric,
    :DocumentsCount,
    :ElectricExpense,
    :Elevation,
    :EntryLevel,
    :FireplacesTotal,
    :FoundationArea,
    :FuelExpense,
    :FurnitureReplacementExpense,
    :GarageSpaces,
    :GardenerExpense,
    :GrossIncome,
    :GrossScheduledIncome,
    :InsuranceExpense,
    :IrrigationWaterRightsAcres,
    :LandLeaseAmount,
    :Latitude,
    :LeasableArea,
    :LeaseAmount,
    :LicensesExpense,
    :ListAgentKeyNumeric,
    :ListOfficeKeyNumeric,
    :ListPrice,
    :ListPriceLow,
    :ListTeamKeyNumeric,
    :ListingKeyNumeric,
    :LivingArea,
    :Longitude,
    :LotSizeAcres,
    :LotSizeArea,
    :LotSizeSquareFeet,
    :MainLevelBathrooms,
    :MainLevelBedrooms,
    :MaintenanceExpense,
    :ManagerExpense,
    :MobileLength,
    :MobileWidth,
    :NetOperatingIncome,
    :NewTaxesExpense,
    :NumberOfBuildings,
    :NumberOfFullTimeEmployees,
    :NumberOfLots,
    :NumberOfPads,
    :NumberOfPartTimeEmployees,
    :NumberOfSeparateElectricMeters,
    :NumberOfSeparateGasMeters,
    :NumberOfSeparateWaterMeters,
    :NumberOfUnitsInCommunity,
    :NumberOfUnitsLeased,
    :NumberOfUnitsMoMo,
    :NumberOfUnitsTotal,
    :NumberOfUnitsVacant,
    :OpenParkingSpaces,
    :OperatingExpense,
    :OriginalListPrice,
    :OtherExpense,
    :ParkingTotal,
    :PastureArea,
    :PestControlExpense,
    :PhotosCount,
    :PoolExpense,
    :PreviousListPrice,
    :ProfessionalManagementExpense,
    :RangeArea,
    :RoomsTotal,
    :SeatingCapacity,
    :ShowingAdvanceNotice,
    :Stories,
    :StoriesTotal,
    :StreetNumberNumeric,
    :SuppliesExpense,
    :TaxAnnualAmount,
    :TaxAssessedValue,
    :TaxOtherAnnualAssessmentAmount,
    :TaxYear,
    :TotalActualRent,
    :TrashExpense,
    :VacancyAllowance,
    :VacancyAllowanceRate,
    :VideosCount,
    :WalkScore,
    :WaterSewerExpense,
    :WoodedArea,
    :WorkmansCompensationExpense,
    :YearBuilt,
    :YearBuiltEffective,
    :YearEstablished,
    :YearsCurrentOwner,
    :AccessCode,
    :AdditionalParcelsDescription,
    :AnchorsCoTenants,
    :AssociationName,
    :AssociationName2,
    :AssociationPhone,
    :AssociationPhone2,
    :BuilderModel,
    :BuilderName,
    :BuildingName,
    :BusinessName,
    :BuyerAgencyCompensation,
    :BuyerAgentDirectPhone,
    :BuyerAgentEmail,
    :BuyerAgentFax,
    :BuyerAgentFirstName,
    :BuyerAgentFullName,
    :BuyerAgentHomePhone,
    :BuyerAgentKey,
    :BuyerAgentLastName,
    :BuyerAgentMiddleName,
    :BuyerAgentMlsId,
    :BuyerAgentMobilePhone,
    :BuyerAgentNamePrefix,
    :BuyerAgentNameSuffix,
    :BuyerAgentOfficePhone,
    :BuyerAgentOfficePhoneExt,
    :BuyerAgentPager,
    :BuyerAgentPreferredPhone,
    :BuyerAgentPreferredPhoneExt,
    :BuyerAgentStateLicense,
    :BuyerAgentTollFreePhone,
    :BuyerAgentURL,
    :BuyerAgentVoiceMail,
    :BuyerAgentVoiceMailExt,
    :BuyerOfficeEmail,
    :BuyerOfficeFax,
    :BuyerOfficeKey,
    :BuyerOfficeMlsId,
    :BuyerOfficeName,
    :BuyerOfficePhone,
    :BuyerOfficePhoneExt,
    :BuyerOfficeURL,
    :BuyerTeamKey,
    :BuyerTeamName,
    :CarrierRoute,
    :CityRegion,
    :CoBuyerAgentDirectPhone,
    :CoBuyerAgentEmail,
    :CoBuyerAgentFax,
    :CoBuyerAgentFirstName,
    :CoBuyerAgentFullName,
    :CoBuyerAgentHomePhone,
    :CoBuyerAgentKey,
    :CoBuyerAgentLastName,
    :CoBuyerAgentMiddleName,
    :CoBuyerAgentMlsId,
    :CoBuyerAgentMobilePhone,
    :CoBuyerAgentNamePrefix,
    :CoBuyerAgentNameSuffix,
    :CoBuyerAgentOfficePhone,
    :CoBuyerAgentOfficePhoneExt,
    :CoBuyerAgentPager,
    :CoBuyerAgentPreferredPhone,
    :CoBuyerAgentPreferredPhoneExt,
    :CoBuyerAgentStateLicense,
    :CoBuyerAgentTollFreePhone,
    :CoBuyerAgentURL,
    :CoBuyerAgentVoiceMail,
    :CoBuyerAgentVoiceMailExt,
    :CoBuyerOfficeEmail,
    :CoBuyerOfficeFax,
    :CoBuyerOfficeKey,
    :CoBuyerOfficeMlsId,
    :CoBuyerOfficeName,
    :CoBuyerOfficePhone,
    :CoBuyerOfficePhoneExt,
    :CoBuyerOfficeURL,
    :CoListAgentDirectPhone,
    :CoListAgentEmail,
    :CoListAgentFax,
    :CoListAgentFirstName,
    :CoListAgentFullName,
    :CoListAgentHomePhone,
    :CoListAgentKey,
    :CoListAgentLastName,
    :CoListAgentMiddleName,
    :CoListAgentMlsId,
    :CoListAgentMobilePhone,
    :CoListAgentNamePrefix,
    :CoListAgentNameSuffix,
    :CoListAgentOfficePhone,
    :CoListAgentOfficePhoneExt,
    :CoListAgentPager,
    :CoListAgentPreferredPhone,
    :CoListAgentPreferredPhoneExt,
    :CoListAgentStateLicense,
    :CoListAgentTollFreePhone,
    :CoListAgentURL,
    :CoListAgentVoiceMail,
    :CoListAgentVoiceMailExt,
    :CoListOfficeEmail,
    :CoListOfficeFax,
    :CoListOfficeKey,
    :CoListOfficeMlsId,
    :CoListOfficeName,
    :CoListOfficePhone,
    :CoListOfficePhoneExt,
    :CoListOfficeURL,
    :ConcessionsComments,
    :ContinentRegion,
    :Contingency,
    :CopyrightNotice,
    :CountryRegion,
    :CrossStreet,
    :DOH1,
    :DOH2,
    :DOH3,
    :Directions,
    :Disclaimer,
    :DistanceToBusComments,
    :DistanceToElectricComments,
    :DistanceToFreewayComments,
    :DistanceToGasComments,
    :DistanceToPhoneServiceComments,
    :DistanceToPlaceofWorshipComments,
    :DistanceToSchoolBusComments,
    :DistanceToSchoolsComments,
    :DistanceToSewerComments,
    :DistanceToShoppingComments,
    :DistanceToStreetComments,
    :DistanceToWaterComments,
    :EntryLocation,
    :Exclusions,
    :FrontageLength,
    :HoursDaysOfOperationDescription,
    :Inclusions,
    :License1,
    :License2,
    :License3,
    :ListAgentDirectPhone,
    :ListAgentEmail,
    :ListAgentFax,
    :ListAgentFirstName,
    :ListAgentFullName,
    :ListAgentHomePhone,
    :ListAgentKey,
    :ListAgentLastName,
    :ListAgentMiddleName,
    :ListAgentMlsId,
    :ListAgentMobilePhone,
    :ListAgentNamePrefix,
    :ListAgentNameSuffix,
    :ListAgentOfficePhone,
    :ListAgentOfficePhoneExt,
    :ListAgentPager,
    :ListAgentPreferredPhone,
    :ListAgentPreferredPhoneExt,
    :ListAgentStateLicense,
    :ListAgentTollFreePhone,
    :ListAgentURL,
    :ListAgentVoiceMail,
    :ListAgentVoiceMailExt,
    :ListOfficeEmail,
    :ListOfficeFax,
    :ListOfficeKey,
    :ListOfficeMlsId,
    :ListOfficeName,
    :ListOfficePhone,
    :ListOfficePhoneExt,
    :ListOfficeURL,
    :ListTeamKey,
    :ListTeamName,
    :ListingId,
    :LockBoxLocation,
    :LockBoxSerialNumber,
    :LotSizeDimensions,
    :Make,
    :MapCoordinate,
    :MapCoordinateSource,
    :MapURL,
    :Model,
    :OccupantName,
    :OccupantPhone,
    :OriginatingSystemID,
    :OriginatingSystemKey,
    :OriginatingSystemName,
    :OtherParking,
    :OwnerName,
    :OwnerPhone,
    :Ownership,
    :ParcelNumber,
    :ParkManagerName,
    :ParkManagerPhone,
    :ParkName,
    :PostalCode,
    :PostalCodePlus4,
    :PrivateOfficeRemarks,
    :PrivateRemarks,
    :PublicRemarks,
    :PublicSurveyRange,
    :PublicSurveySection,
    :PublicSurveyTownship,
    :RVParkingDimensions,
    :SerialU,
    :SerialX,
    :SerialXX,
    :ShowingContactName,
    :ShowingContactPhone,
    :ShowingContactPhoneExt,
    :ShowingInstructions,
    :SourceSystemID,
    :SourceSystemKey,
    :SourceSystemName,
    :StateRegion,
    :StreetAdditionalInfo,
    :StreetName,
    :StreetNumber,
    :StreetSuffixModifier,
    :SubAgencyCompensation,
    :SubdivisionName,
    :SyndicationRemarks,
    :TaxBlock,
    :TaxBookNumber,
    :TaxLegalDescription,
    :TaxLot,
    :TaxMapNumber,
    :TaxParcelLetter,
    :TaxTract,
    :Topography,
    :Township,
    :TransactionBrokerCompensation,
    :UnitNumber,
    :UniversalPropertyId,
    :UniversalPropertySubId,
    :UnparsedAddress,
    :VirtualTourURLBranded,
    :VirtualTourURLUnbranded,
    :WaterBodyName,
    :YearBuiltDetails,
    :Zoning,
    :ZoningDescription,
    :Appliances,
    :AccessibilityFeatures,
    :ArchitecturalStyle,
    :AssociationAmenities,
    :AssociationFeeIncludes,
    :Basement,
    :BodyType,
    :BuildingFeatures,
    :BusinessType,
    :BuyerAgentDesignation,
    :BuyerFinancing,
    :CoBuyerAgentDesignation,
    :CoListAgentDesignation,
    :CommonWalls,
    :CommunityFeatures,
    :ConstructionMaterials,
    :Cooling,
    :CurrentFinancing,
    :CurrentUse,
    :DevelopmentStatus,
    :Disclosures,
    :DocumentsAvailable,
    :DoorFeatures,
    :Electric,
    :ExistingLeaseType,
    :ExteriorFeatures,
    :Fencing,
    :FinancialDataSource,
    :FireplaceFeatures,
    :Flooring,
    :FoundationDetails,
    :FrontageType,
    :GreenBuildingVerificationType,
    :GreenEnergyEfficient,
    :GreenEnergyGeneration,
    :GreenIndoorAirQuality,
    :GreenLocation,
    :GreenSustainability,
    :GreenWaterConservation,
    :Heating,
    :HorseAmenities,
    :HoursDaysOfOperation,
    :IncomeIncludes,
    :InteriorFeatures,
    :IrrigationSource,
    :LaborInformation,
    :LaundryFeatures,
    :LeaseRenewalCompensation,
    :Levels,
    :ListAgentDesignation,
    :ListingTerms,
    :LockBoxType,
    :LotFeatures,
    :OperatingExpenseIncludes,
    :OtherEquipment,
    :OtherStructures,
    :OwnerPays,
    :ParkingFeatures,
    :PatioAndPorchFeatures,
    :PetsAllowed,
    :PoolFeatures,
    :Possession,
    :PossibleUse,
    :PowerProductionType,
    :PropertyCondition,
    :RentIncludes,
    :RoadFrontageType,
    :RoadResponsibility,
    :RoadSurfaceType,
    :Roof,
    :RoomType,
    :SecurityFeatures,
    :Sewer,
    :ShowingContactType,
    :ShowingDays,
    :ShowingRequirements,
    :Skirt,
    :SpaFeatures,
    :SpecialLicenses,
    :SpecialListingConditions,
    :StructureType,
    :SyndicateTo,
    :TaxStatusCurrent,
    :TenantPays,
    :UnitTypeType,
    :Utilities,
    :Vegetation,
    :View,
    :WaterSource,
    :WaterfrontFeatures,
    :WindowFeatures,
    :AboveGradeFinishedAreaSource,
    :AboveGradeFinishedAreaUnits,
    :AssociationFee2Frequency,
    :AssociationFeeFrequency,
    :BelowGradeFinishedAreaSource,
    :BelowGradeFinishedAreaUnits,
    :BuildingAreaSource,
    :BuildingAreaUnits,
    :BuyerAgencyCompensationType,
    :BuyerAgentAOR,
    :BuyerOfficeAOR,
    :City,
    :CoBuyerAgentAOR,
    :CoBuyerOfficeAOR,
    :CoListAgentAOR,
    :CoListOfficeAOR,
    :CommonInterest,
    :Concessions,
    :Country,
    :CountyOrParish,
    :DirectionFaces,
    :DistanceToBusUnits,
    :DistanceToElectricUnits,
    :DistanceToFreewayUnits,
    :DistanceToGasUnits,
    :DistanceToPhoneServiceUnits,
    :DistanceToPlaceofWorshipUnits,
    :DistanceToSchoolBusUnits,
    :DistanceToSchoolsUnits,
    :DistanceToSewerUnits,
    :DistanceToShoppingUnits,
    :DistanceToStreetUnits,
    :DistanceToWaterUnits,
    :ElementarySchool,
    :ElementarySchoolDistrict,
    :ElevationUnits,
    :FarmLandAreaSource,
    :FarmLandAreaUnits,
    :Furnished,
    :HighSchool,
    :HighSchoolDistrict,
    :LandLeaseAmountFrequency,
    :LeasableAreaUnits,
    :LeaseAmountFrequency,
    :LeaseTerm,
    :ListAOR,
    :ListAgentAOR,
    :ListOfficeAOR,
    :ListingAgreement,
    :ListingService,
    :LivingAreaSource,
    :LivingAreaUnits,
    :LotDimensionsSource,
    :LotSizeSource,
    :LotSizeUnits,
    :MLSAreaMajor,
    :MLSAreaMinor,
    :MajorChangeType,
    :MiddleOrJuniorSchool,
    :MiddleOrJuniorSchoolDistrict,
    :MlsStatus,
    :MobileDimUnits,
    :OccupantType,
    :OwnershipType,
    :PostalCity,
    :PropertySubType,
    :PropertyType,
    :StandardStatus,
    :StateOrProvince,
    :StreetDirPrefix,
    :StreetDirSuffix,
    :StreetSuffix,
    :SubAgencyCompensationType,
    :TransactionBrokerCompensationType,
    :UnitsFurnished,
    :YearBuiltSource,
    :DocumentsChangeTimestamp,
    :MajorChangeTimestamp,
    :ModificationTimestamp,
    :OffMarketTimestamp,
    :OnMarketTimestamp,
    :OriginalEntryTimestamp,
    :PendingTimestamp,
    :PhotosChangeTimestamp,
    :PriceChangeTimestamp,
    :ShowingEndTime,
    :ShowingStartTime,
    :StatusChangeTimestamp,
    :VideosChangeTimestamp,
    :BuyerAgent,
    :CoBuyerAgent,
    :CoListAgent,
    :ListAgent,
    :BuyerOffice,
    :CoBuyerOffice,
    :CoListOffice,
    :ListOffice,
    :OriginatingSystem,
    :SourceSystem,
    :ListTeam,
    :BuyerTeam,
    :ContactListings,
    :Favorites,
    :OpenHouse,
    :GreenBuildingVerifications,
    :PowerProductions,
    :Rooms,
    :UnitTypes,
    :Shares,
    :Showings,
    :Transactions,
    :Media
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :Location => FoyerAPI.Model.Location.t | nil,
    :ListingKey => String.t | nil,
    :AdditionalParcelsYN => boolean() | nil,
    :AssociationYN => boolean() | nil,
    :AttachedGarageYN => boolean() | nil,
    :BasementYN => boolean() | nil,
    :CarportYN => boolean() | nil,
    :CoolingYN => boolean() | nil,
    :CropsIncludedYN => boolean() | nil,
    :DualVariableCompensationYN => boolean() | nil,
    :ElectricOnPropertyYN => boolean() | nil,
    :FarmCreditServiceInclYN => boolean() | nil,
    :FireplaceYN => boolean() | nil,
    :GarageYN => boolean() | nil,
    :GrazingPermitsBlmYN => boolean() | nil,
    :GrazingPermitsForestServiceYN => boolean() | nil,
    :GrazingPermitsPrivateYN => boolean() | nil,
    :HabitableResidenceYN => boolean() | nil,
    :HeatingYN => boolean() | nil,
    :HomeWarrantyYN => boolean() | nil,
    :HorseYN => boolean() | nil,
    :InternetAddressDisplayYN => boolean() | nil,
    :InternetAutomatedValuationDisplayYN => boolean() | nil,
    :InternetConsumerCommentYN => boolean() | nil,
    :InternetEntireListingDisplayYN => boolean() | nil,
    :IrrigationWaterRightsYN => boolean() | nil,
    :LandLeaseYN => boolean() | nil,
    :LeaseAssignableYN => boolean() | nil,
    :LeaseConsideredYN => boolean() | nil,
    :LeaseRenewalOptionYN => boolean() | nil,
    :MobileHomeRemainsYN => boolean() | nil,
    :NewConstructionYN => boolean() | nil,
    :OpenParkingYN => boolean() | nil,
    :PoolPrivateYN => boolean() | nil,
    :PropertyAttachedYN => boolean() | nil,
    :RentControlYN => boolean() | nil,
    :SeniorCommunityYN => boolean() | nil,
    :ShowingAttendedYN => boolean() | nil,
    :SignOnPropertyYN => boolean() | nil,
    :SpaYN => boolean() | nil,
    :ViewYN => boolean() | nil,
    :WaterfrontYN => boolean() | nil,
    :AvailabilityDate => Date.t | nil,
    :CancellationDate => Date.t | nil,
    :CloseDate => Date.t | nil,
    :ContingentDate => Date.t | nil,
    :ContractStatusChangeDate => Date.t | nil,
    :ExpirationDate => Date.t | nil,
    :LandLeaseExpirationDate => Date.t | nil,
    :LeaseExpiration => Date.t | nil,
    :ListingContractDate => Date.t | nil,
    :OffMarketDate => Date.t | nil,
    :OnMarketDate => Date.t | nil,
    :PurchaseContractDate => Date.t | nil,
    :WithdrawnDate => Date.t | nil,
    :AboveGradeFinishedArea => float() | nil,
    :AssociationFee => float() | nil,
    :AssociationFee2 => float() | nil,
    :BathroomsFull => float() | nil,
    :BathroomsHalf => float() | nil,
    :BathroomsOneQuarter => float() | nil,
    :BathroomsPartial => float() | nil,
    :BathroomsThreeQuarter => float() | nil,
    :BathroomsTotalInteger => float() | nil,
    :BedroomsPossible => float() | nil,
    :BedroomsTotal => float() | nil,
    :BelowGradeFinishedArea => float() | nil,
    :BuildingAreaTotal => float() | nil,
    :BuyerAgentKeyNumeric => float() | nil,
    :BuyerOfficeKeyNumeric => float() | nil,
    :BuyerTeamKeyNumeric => float() | nil,
    :CableTvExpense => float() | nil,
    :CapRate => float() | nil,
    :CarportSpaces => float() | nil,
    :ClosePrice => float() | nil,
    :CoBuyerAgentKeyNumeric => float() | nil,
    :CoBuyerOfficeKeyNumeric => float() | nil,
    :CoListAgentKeyNumeric => float() | nil,
    :CoListOfficeKeyNumeric => float() | nil,
    :ConcessionsAmount => float() | nil,
    :CoveredSpaces => float() | nil,
    :CultivatedArea => float() | nil,
    :CumulativeDaysOnMarket => float() | nil,
    :DaysOnMarket => float() | nil,
    :DistanceToBusNumeric => float() | nil,
    :DistanceToElectricNumeric => float() | nil,
    :DistanceToFreewayNumeric => float() | nil,
    :DistanceToGasNumeric => float() | nil,
    :DistanceToPhoneServiceNumeric => float() | nil,
    :DistanceToPlaceofWorshipNumeric => float() | nil,
    :DistanceToSchoolBusNumeric => float() | nil,
    :DistanceToSchoolsNumeric => float() | nil,
    :DistanceToSewerNumeric => float() | nil,
    :DistanceToShoppingNumeric => float() | nil,
    :DistanceToStreetNumeric => float() | nil,
    :DistanceToWaterNumeric => float() | nil,
    :DocumentsCount => float() | nil,
    :ElectricExpense => float() | nil,
    :Elevation => float() | nil,
    :EntryLevel => float() | nil,
    :FireplacesTotal => float() | nil,
    :FoundationArea => float() | nil,
    :FuelExpense => float() | nil,
    :FurnitureReplacementExpense => float() | nil,
    :GarageSpaces => float() | nil,
    :GardenerExpense => float() | nil,
    :GrossIncome => float() | nil,
    :GrossScheduledIncome => float() | nil,
    :InsuranceExpense => float() | nil,
    :IrrigationWaterRightsAcres => float() | nil,
    :LandLeaseAmount => float() | nil,
    :Latitude => float() | nil,
    :LeasableArea => float() | nil,
    :LeaseAmount => float() | nil,
    :LicensesExpense => float() | nil,
    :ListAgentKeyNumeric => float() | nil,
    :ListOfficeKeyNumeric => float() | nil,
    :ListPrice => float() | nil,
    :ListPriceLow => float() | nil,
    :ListTeamKeyNumeric => float() | nil,
    :ListingKeyNumeric => float() | nil,
    :LivingArea => float() | nil,
    :Longitude => float() | nil,
    :LotSizeAcres => float() | nil,
    :LotSizeArea => float() | nil,
    :LotSizeSquareFeet => float() | nil,
    :MainLevelBathrooms => float() | nil,
    :MainLevelBedrooms => float() | nil,
    :MaintenanceExpense => float() | nil,
    :ManagerExpense => float() | nil,
    :MobileLength => float() | nil,
    :MobileWidth => float() | nil,
    :NetOperatingIncome => float() | nil,
    :NewTaxesExpense => float() | nil,
    :NumberOfBuildings => float() | nil,
    :NumberOfFullTimeEmployees => float() | nil,
    :NumberOfLots => float() | nil,
    :NumberOfPads => float() | nil,
    :NumberOfPartTimeEmployees => float() | nil,
    :NumberOfSeparateElectricMeters => float() | nil,
    :NumberOfSeparateGasMeters => float() | nil,
    :NumberOfSeparateWaterMeters => float() | nil,
    :NumberOfUnitsInCommunity => float() | nil,
    :NumberOfUnitsLeased => float() | nil,
    :NumberOfUnitsMoMo => float() | nil,
    :NumberOfUnitsTotal => float() | nil,
    :NumberOfUnitsVacant => float() | nil,
    :OpenParkingSpaces => float() | nil,
    :OperatingExpense => float() | nil,
    :OriginalListPrice => float() | nil,
    :OtherExpense => float() | nil,
    :ParkingTotal => float() | nil,
    :PastureArea => float() | nil,
    :PestControlExpense => float() | nil,
    :PhotosCount => float() | nil,
    :PoolExpense => float() | nil,
    :PreviousListPrice => float() | nil,
    :ProfessionalManagementExpense => float() | nil,
    :RangeArea => float() | nil,
    :RoomsTotal => float() | nil,
    :SeatingCapacity => float() | nil,
    :ShowingAdvanceNotice => float() | nil,
    :Stories => float() | nil,
    :StoriesTotal => float() | nil,
    :StreetNumberNumeric => float() | nil,
    :SuppliesExpense => float() | nil,
    :TaxAnnualAmount => float() | nil,
    :TaxAssessedValue => float() | nil,
    :TaxOtherAnnualAssessmentAmount => float() | nil,
    :TaxYear => float() | nil,
    :TotalActualRent => float() | nil,
    :TrashExpense => float() | nil,
    :VacancyAllowance => float() | nil,
    :VacancyAllowanceRate => float() | nil,
    :VideosCount => float() | nil,
    :WalkScore => float() | nil,
    :WaterSewerExpense => float() | nil,
    :WoodedArea => float() | nil,
    :WorkmansCompensationExpense => float() | nil,
    :YearBuilt => float() | nil,
    :YearBuiltEffective => float() | nil,
    :YearEstablished => float() | nil,
    :YearsCurrentOwner => float() | nil,
    :AccessCode => String.t | nil,
    :AdditionalParcelsDescription => String.t | nil,
    :AnchorsCoTenants => String.t | nil,
    :AssociationName => String.t | nil,
    :AssociationName2 => String.t | nil,
    :AssociationPhone => String.t | nil,
    :AssociationPhone2 => String.t | nil,
    :BuilderModel => String.t | nil,
    :BuilderName => String.t | nil,
    :BuildingName => String.t | nil,
    :BusinessName => String.t | nil,
    :BuyerAgencyCompensation => String.t | nil,
    :BuyerAgentDirectPhone => String.t | nil,
    :BuyerAgentEmail => String.t | nil,
    :BuyerAgentFax => String.t | nil,
    :BuyerAgentFirstName => String.t | nil,
    :BuyerAgentFullName => String.t | nil,
    :BuyerAgentHomePhone => String.t | nil,
    :BuyerAgentKey => String.t | nil,
    :BuyerAgentLastName => String.t | nil,
    :BuyerAgentMiddleName => String.t | nil,
    :BuyerAgentMlsId => String.t | nil,
    :BuyerAgentMobilePhone => String.t | nil,
    :BuyerAgentNamePrefix => String.t | nil,
    :BuyerAgentNameSuffix => String.t | nil,
    :BuyerAgentOfficePhone => String.t | nil,
    :BuyerAgentOfficePhoneExt => String.t | nil,
    :BuyerAgentPager => String.t | nil,
    :BuyerAgentPreferredPhone => String.t | nil,
    :BuyerAgentPreferredPhoneExt => String.t | nil,
    :BuyerAgentStateLicense => String.t | nil,
    :BuyerAgentTollFreePhone => String.t | nil,
    :BuyerAgentURL => String.t | nil,
    :BuyerAgentVoiceMail => String.t | nil,
    :BuyerAgentVoiceMailExt => String.t | nil,
    :BuyerOfficeEmail => String.t | nil,
    :BuyerOfficeFax => String.t | nil,
    :BuyerOfficeKey => String.t | nil,
    :BuyerOfficeMlsId => String.t | nil,
    :BuyerOfficeName => String.t | nil,
    :BuyerOfficePhone => String.t | nil,
    :BuyerOfficePhoneExt => String.t | nil,
    :BuyerOfficeURL => String.t | nil,
    :BuyerTeamKey => String.t | nil,
    :BuyerTeamName => String.t | nil,
    :CarrierRoute => String.t | nil,
    :CityRegion => String.t | nil,
    :CoBuyerAgentDirectPhone => String.t | nil,
    :CoBuyerAgentEmail => String.t | nil,
    :CoBuyerAgentFax => String.t | nil,
    :CoBuyerAgentFirstName => String.t | nil,
    :CoBuyerAgentFullName => String.t | nil,
    :CoBuyerAgentHomePhone => String.t | nil,
    :CoBuyerAgentKey => String.t | nil,
    :CoBuyerAgentLastName => String.t | nil,
    :CoBuyerAgentMiddleName => String.t | nil,
    :CoBuyerAgentMlsId => String.t | nil,
    :CoBuyerAgentMobilePhone => String.t | nil,
    :CoBuyerAgentNamePrefix => String.t | nil,
    :CoBuyerAgentNameSuffix => String.t | nil,
    :CoBuyerAgentOfficePhone => String.t | nil,
    :CoBuyerAgentOfficePhoneExt => String.t | nil,
    :CoBuyerAgentPager => String.t | nil,
    :CoBuyerAgentPreferredPhone => String.t | nil,
    :CoBuyerAgentPreferredPhoneExt => String.t | nil,
    :CoBuyerAgentStateLicense => String.t | nil,
    :CoBuyerAgentTollFreePhone => String.t | nil,
    :CoBuyerAgentURL => String.t | nil,
    :CoBuyerAgentVoiceMail => String.t | nil,
    :CoBuyerAgentVoiceMailExt => String.t | nil,
    :CoBuyerOfficeEmail => String.t | nil,
    :CoBuyerOfficeFax => String.t | nil,
    :CoBuyerOfficeKey => String.t | nil,
    :CoBuyerOfficeMlsId => String.t | nil,
    :CoBuyerOfficeName => String.t | nil,
    :CoBuyerOfficePhone => String.t | nil,
    :CoBuyerOfficePhoneExt => String.t | nil,
    :CoBuyerOfficeURL => String.t | nil,
    :CoListAgentDirectPhone => String.t | nil,
    :CoListAgentEmail => String.t | nil,
    :CoListAgentFax => String.t | nil,
    :CoListAgentFirstName => String.t | nil,
    :CoListAgentFullName => String.t | nil,
    :CoListAgentHomePhone => String.t | nil,
    :CoListAgentKey => String.t | nil,
    :CoListAgentLastName => String.t | nil,
    :CoListAgentMiddleName => String.t | nil,
    :CoListAgentMlsId => String.t | nil,
    :CoListAgentMobilePhone => String.t | nil,
    :CoListAgentNamePrefix => String.t | nil,
    :CoListAgentNameSuffix => String.t | nil,
    :CoListAgentOfficePhone => String.t | nil,
    :CoListAgentOfficePhoneExt => String.t | nil,
    :CoListAgentPager => String.t | nil,
    :CoListAgentPreferredPhone => String.t | nil,
    :CoListAgentPreferredPhoneExt => String.t | nil,
    :CoListAgentStateLicense => String.t | nil,
    :CoListAgentTollFreePhone => String.t | nil,
    :CoListAgentURL => String.t | nil,
    :CoListAgentVoiceMail => String.t | nil,
    :CoListAgentVoiceMailExt => String.t | nil,
    :CoListOfficeEmail => String.t | nil,
    :CoListOfficeFax => String.t | nil,
    :CoListOfficeKey => String.t | nil,
    :CoListOfficeMlsId => String.t | nil,
    :CoListOfficeName => String.t | nil,
    :CoListOfficePhone => String.t | nil,
    :CoListOfficePhoneExt => String.t | nil,
    :CoListOfficeURL => String.t | nil,
    :ConcessionsComments => String.t | nil,
    :ContinentRegion => String.t | nil,
    :Contingency => String.t | nil,
    :CopyrightNotice => String.t | nil,
    :CountryRegion => String.t | nil,
    :CrossStreet => String.t | nil,
    :DOH1 => String.t | nil,
    :DOH2 => String.t | nil,
    :DOH3 => String.t | nil,
    :Directions => String.t | nil,
    :Disclaimer => String.t | nil,
    :DistanceToBusComments => String.t | nil,
    :DistanceToElectricComments => String.t | nil,
    :DistanceToFreewayComments => String.t | nil,
    :DistanceToGasComments => String.t | nil,
    :DistanceToPhoneServiceComments => String.t | nil,
    :DistanceToPlaceofWorshipComments => String.t | nil,
    :DistanceToSchoolBusComments => String.t | nil,
    :DistanceToSchoolsComments => String.t | nil,
    :DistanceToSewerComments => String.t | nil,
    :DistanceToShoppingComments => String.t | nil,
    :DistanceToStreetComments => String.t | nil,
    :DistanceToWaterComments => String.t | nil,
    :EntryLocation => String.t | nil,
    :Exclusions => String.t | nil,
    :FrontageLength => String.t | nil,
    :HoursDaysOfOperationDescription => String.t | nil,
    :Inclusions => String.t | nil,
    :License1 => String.t | nil,
    :License2 => String.t | nil,
    :License3 => String.t | nil,
    :ListAgentDirectPhone => String.t | nil,
    :ListAgentEmail => String.t | nil,
    :ListAgentFax => String.t | nil,
    :ListAgentFirstName => String.t | nil,
    :ListAgentFullName => String.t | nil,
    :ListAgentHomePhone => String.t | nil,
    :ListAgentKey => String.t | nil,
    :ListAgentLastName => String.t | nil,
    :ListAgentMiddleName => String.t | nil,
    :ListAgentMlsId => String.t | nil,
    :ListAgentMobilePhone => String.t | nil,
    :ListAgentNamePrefix => String.t | nil,
    :ListAgentNameSuffix => String.t | nil,
    :ListAgentOfficePhone => String.t | nil,
    :ListAgentOfficePhoneExt => String.t | nil,
    :ListAgentPager => String.t | nil,
    :ListAgentPreferredPhone => String.t | nil,
    :ListAgentPreferredPhoneExt => String.t | nil,
    :ListAgentStateLicense => String.t | nil,
    :ListAgentTollFreePhone => String.t | nil,
    :ListAgentURL => String.t | nil,
    :ListAgentVoiceMail => String.t | nil,
    :ListAgentVoiceMailExt => String.t | nil,
    :ListOfficeEmail => String.t | nil,
    :ListOfficeFax => String.t | nil,
    :ListOfficeKey => String.t | nil,
    :ListOfficeMlsId => String.t | nil,
    :ListOfficeName => String.t | nil,
    :ListOfficePhone => String.t | nil,
    :ListOfficePhoneExt => String.t | nil,
    :ListOfficeURL => String.t | nil,
    :ListTeamKey => String.t | nil,
    :ListTeamName => String.t | nil,
    :ListingId => String.t | nil,
    :LockBoxLocation => String.t | nil,
    :LockBoxSerialNumber => String.t | nil,
    :LotSizeDimensions => String.t | nil,
    :Make => String.t | nil,
    :MapCoordinate => String.t | nil,
    :MapCoordinateSource => String.t | nil,
    :MapURL => String.t | nil,
    :Model => String.t | nil,
    :OccupantName => String.t | nil,
    :OccupantPhone => String.t | nil,
    :OriginatingSystemID => String.t | nil,
    :OriginatingSystemKey => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :OtherParking => String.t | nil,
    :OwnerName => String.t | nil,
    :OwnerPhone => String.t | nil,
    :Ownership => [String.t] | nil,
    :ParcelNumber => String.t | nil,
    :ParkManagerName => String.t | nil,
    :ParkManagerPhone => String.t | nil,
    :ParkName => String.t | nil,
    :PostalCode => String.t | nil,
    :PostalCodePlus4 => String.t | nil,
    :PrivateOfficeRemarks => String.t | nil,
    :PrivateRemarks => String.t | nil,
    :PublicRemarks => String.t | nil,
    :PublicSurveyRange => String.t | nil,
    :PublicSurveySection => String.t | nil,
    :PublicSurveyTownship => String.t | nil,
    :RVParkingDimensions => String.t | nil,
    :SerialU => String.t | nil,
    :SerialX => String.t | nil,
    :SerialXX => String.t | nil,
    :ShowingContactName => String.t | nil,
    :ShowingContactPhone => String.t | nil,
    :ShowingContactPhoneExt => String.t | nil,
    :ShowingInstructions => String.t | nil,
    :SourceSystemID => String.t | nil,
    :SourceSystemKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :StateRegion => String.t | nil,
    :StreetAdditionalInfo => String.t | nil,
    :StreetName => String.t | nil,
    :StreetNumber => String.t | nil,
    :StreetSuffixModifier => String.t | nil,
    :SubAgencyCompensation => String.t | nil,
    :SubdivisionName => String.t | nil,
    :SyndicationRemarks => String.t | nil,
    :TaxBlock => String.t | nil,
    :TaxBookNumber => String.t | nil,
    :TaxLegalDescription => String.t | nil,
    :TaxLot => String.t | nil,
    :TaxMapNumber => String.t | nil,
    :TaxParcelLetter => String.t | nil,
    :TaxTract => String.t | nil,
    :Topography => String.t | nil,
    :Township => String.t | nil,
    :TransactionBrokerCompensation => String.t | nil,
    :UnitNumber => String.t | nil,
    :UniversalPropertyId => String.t | nil,
    :UniversalPropertySubId => String.t | nil,
    :UnparsedAddress => String.t | nil,
    :VirtualTourURLBranded => String.t | nil,
    :VirtualTourURLUnbranded => String.t | nil,
    :WaterBodyName => String.t | nil,
    :YearBuiltDetails => String.t | nil,
    :Zoning => String.t | nil,
    :ZoningDescription => String.t | nil,
    :Appliances => [String.t] | nil,
    :AccessibilityFeatures => [String.t] | nil,
    :ArchitecturalStyle => [String.t] | nil,
    :AssociationAmenities => String.t | nil,
    :AssociationFeeIncludes => String.t | nil,
    :Basement => String.t | nil,
    :BodyType => String.t | nil,
    :BuildingFeatures => [String.t] | nil,
    :BusinessType => [String.t] | nil,
    :BuyerAgentDesignation => [String.t] | nil,
    :BuyerFinancing => [String.t] | nil,
    :CoBuyerAgentDesignation => [String.t] | nil,
    :CoListAgentDesignation => [String.t] | nil,
    :CommonWalls => [String.t] | nil,
    :CommunityFeatures => [String.t] | nil,
    :ConstructionMaterials => [String.t] | nil,
    :Cooling => [String.t] | nil,
    :CurrentFinancing => [String.t] | nil,
    :CurrentUse => [String.t] | nil,
    :DevelopmentStatus => [String.t] | nil,
    :Disclosures => [String.t] | nil,
    :DocumentsAvailable => [String.t] | nil,
    :DoorFeatures => [String.t] | nil,
    :Electric => [String.t] | nil,
    :ExistingLeaseType => [String.t] | nil,
    :ExteriorFeatures => [String.t] | nil,
    :Fencing => [String.t] | nil,
    :FinancialDataSource => [String.t] | nil,
    :FireplaceFeatures => [String.t] | nil,
    :Flooring => [String.t] | nil,
    :FoundationDetails => [String.t] | nil,
    :FrontageType => [String.t] | nil,
    :GreenBuildingVerificationType => [String.t] | nil,
    :GreenEnergyEfficient => [String.t] | nil,
    :GreenEnergyGeneration => [String.t] | nil,
    :GreenIndoorAirQuality => [String.t] | nil,
    :GreenLocation => [String.t] | nil,
    :GreenSustainability => [String.t] | nil,
    :GreenWaterConservation => [String.t] | nil,
    :Heating => [String.t] | nil,
    :HorseAmenities => [String.t] | nil,
    :HoursDaysOfOperation => [String.t] | nil,
    :IncomeIncludes => [String.t] | nil,
    :InteriorFeatures => [String.t] | nil,
    :IrrigationSource => [String.t] | nil,
    :LaborInformation => [String.t] | nil,
    :LaundryFeatures => [String.t] | nil,
    :LeaseRenewalCompensation => [String.t] | nil,
    :Levels => [String.t] | nil,
    :ListAgentDesignation => [String.t] | nil,
    :ListingTerms => [String.t] | nil,
    :LockBoxType => [String.t] | nil,
    :LotFeatures => [String.t] | nil,
    :OperatingExpenseIncludes => [String.t] | nil,
    :OtherEquipment => [String.t] | nil,
    :OtherStructures => [String.t] | nil,
    :OwnerPays => [String.t] | nil,
    :ParkingFeatures => [String.t] | nil,
    :PatioAndPorchFeatures => [String.t] | nil,
    :PetsAllowed => [String.t] | nil,
    :PoolFeatures => [String.t] | nil,
    :Possession => [String.t] | nil,
    :PossibleUse => [String.t] | nil,
    :PowerProductionType => [String.t] | nil,
    :PropertyCondition => [String.t] | nil,
    :RentIncludes => [String.t] | nil,
    :RoadFrontageType => [String.t] | nil,
    :RoadResponsibility => [String.t] | nil,
    :RoadSurfaceType => [String.t] | nil,
    :Roof => [String.t] | nil,
    :RoomType => [String.t] | nil,
    :SecurityFeatures => [String.t] | nil,
    :Sewer => [String.t] | nil,
    :ShowingContactType => [String.t] | nil,
    :ShowingDays => [String.t] | nil,
    :ShowingRequirements => [String.t] | nil,
    :Skirt => [String.t] | nil,
    :SpaFeatures => [String.t] | nil,
    :SpecialLicenses => [String.t] | nil,
    :SpecialListingConditions => [String.t] | nil,
    :StructureType => [String.t] | nil,
    :SyndicateTo => [String.t] | nil,
    :TaxStatusCurrent => [String.t] | nil,
    :TenantPays => [String.t] | nil,
    :UnitTypeType => [String.t] | nil,
    :Utilities => [String.t] | nil,
    :Vegetation => [String.t] | nil,
    :View => [String.t] | nil,
    :WaterSource => [String.t] | nil,
    :WaterfrontFeatures => [String.t] | nil,
    :WindowFeatures => [String.t] | nil,
    :AboveGradeFinishedAreaSource => String.t | nil,
    :AboveGradeFinishedAreaUnits => String.t | nil,
    :AssociationFee2Frequency => String.t | nil,
    :AssociationFeeFrequency => String.t | nil,
    :BelowGradeFinishedAreaSource => String.t | nil,
    :BelowGradeFinishedAreaUnits => String.t | nil,
    :BuildingAreaSource => String.t | nil,
    :BuildingAreaUnits => String.t | nil,
    :BuyerAgencyCompensationType => String.t | nil,
    :BuyerAgentAOR => String.t | nil,
    :BuyerOfficeAOR => String.t | nil,
    :City => String.t | nil,
    :CoBuyerAgentAOR => String.t | nil,
    :CoBuyerOfficeAOR => String.t | nil,
    :CoListAgentAOR => String.t | nil,
    :CoListOfficeAOR => String.t | nil,
    :CommonInterest => String.t | nil,
    :Concessions => String.t | nil,
    :Country => String.t | nil,
    :CountyOrParish => String.t | nil,
    :DirectionFaces => String.t | nil,
    :DistanceToBusUnits => String.t | nil,
    :DistanceToElectricUnits => String.t | nil,
    :DistanceToFreewayUnits => String.t | nil,
    :DistanceToGasUnits => String.t | nil,
    :DistanceToPhoneServiceUnits => String.t | nil,
    :DistanceToPlaceofWorshipUnits => String.t | nil,
    :DistanceToSchoolBusUnits => String.t | nil,
    :DistanceToSchoolsUnits => String.t | nil,
    :DistanceToSewerUnits => String.t | nil,
    :DistanceToShoppingUnits => String.t | nil,
    :DistanceToStreetUnits => String.t | nil,
    :DistanceToWaterUnits => String.t | nil,
    :ElementarySchool => String.t | nil,
    :ElementarySchoolDistrict => String.t | nil,
    :ElevationUnits => String.t | nil,
    :FarmLandAreaSource => String.t | nil,
    :FarmLandAreaUnits => String.t | nil,
    :Furnished => String.t | nil,
    :HighSchool => String.t | nil,
    :HighSchoolDistrict => String.t | nil,
    :LandLeaseAmountFrequency => String.t | nil,
    :LeasableAreaUnits => String.t | nil,
    :LeaseAmountFrequency => String.t | nil,
    :LeaseTerm => String.t | nil,
    :ListAOR => String.t | nil,
    :ListAgentAOR => String.t | nil,
    :ListOfficeAOR => String.t | nil,
    :ListingAgreement => String.t | nil,
    :ListingService => String.t | nil,
    :LivingAreaSource => String.t | nil,
    :LivingAreaUnits => String.t | nil,
    :LotDimensionsSource => String.t | nil,
    :LotSizeSource => String.t | nil,
    :LotSizeUnits => String.t | nil,
    :MLSAreaMajor => String.t | nil,
    :MLSAreaMinor => String.t | nil,
    :MajorChangeType => String.t | nil,
    :MiddleOrJuniorSchool => String.t | nil,
    :MiddleOrJuniorSchoolDistrict => String.t | nil,
    :MlsStatus => String.t | nil,
    :MobileDimUnits => String.t | nil,
    :OccupantType => String.t | nil,
    :OwnershipType => String.t | nil,
    :PostalCity => String.t | nil,
    :PropertySubType => String.t | nil,
    :PropertyType => String.t | nil,
    :StandardStatus => String.t | nil,
    :StateOrProvince => String.t | nil,
    :StreetDirPrefix => String.t | nil,
    :StreetDirSuffix => String.t | nil,
    :StreetSuffix => String.t | nil,
    :SubAgencyCompensationType => String.t | nil,
    :TransactionBrokerCompensationType => String.t | nil,
    :UnitsFurnished => String.t | nil,
    :YearBuiltSource => String.t | nil,
    :DocumentsChangeTimestamp => Date.t | nil,
    :MajorChangeTimestamp => Date.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OffMarketTimestamp => Date.t | nil,
    :OnMarketTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :PendingTimestamp => Date.t | nil,
    :PhotosChangeTimestamp => Date.t | nil,
    :PriceChangeTimestamp => Date.t | nil,
    :ShowingEndTime => Date.t | nil,
    :ShowingStartTime => Date.t | nil,
    :StatusChangeTimestamp => Date.t | nil,
    :VideosChangeTimestamp => Date.t | nil,
    :BuyerAgent => FoyerAPI.Model.Member.t | nil,
    :CoBuyerAgent => FoyerAPI.Model.Member.t | nil,
    :CoListAgent => FoyerAPI.Model.Member.t | nil,
    :ListAgent => FoyerAPI.Model.Member.t | nil,
    :BuyerOffice => FoyerAPI.Model.Office.t | nil,
    :CoBuyerOffice => FoyerAPI.Model.Office.t | nil,
    :CoListOffice => FoyerAPI.Model.Office.t | nil,
    :ListOffice => FoyerAPI.Model.Office.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :ListTeam => FoyerAPI.Model.Teams.t | nil,
    :BuyerTeam => FoyerAPI.Model.Teams.t | nil,
    :ContactListings => [FoyerAPI.Model.ContactListings.t] | nil,
    :Favorites => [FoyerAPI.Model.Favorite.t] | nil,
    :OpenHouse => [FoyerAPI.Model.OpenHouse.t] | nil,
    :GreenBuildingVerifications => [FoyerAPI.Model.PropertyGreenVerification.t] | nil,
    :PowerProductions => [FoyerAPI.Model.PropertyPowerProduction.t] | nil,
    :Rooms => [FoyerAPI.Model.PropertyRooms.t] | nil,
    :UnitTypes => [FoyerAPI.Model.PropertyUnitTypes.t] | nil,
    :Shares => [FoyerAPI.Model.Share.t] | nil,
    :Showings => [FoyerAPI.Model.Showing.t] | nil,
    :Transactions => [FoyerAPI.Model.Transaction.t] | nil,
    :Media => [FoyerAPI.Model.Media.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Property do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:Location, :struct, FoyerAPI.Model.Location, options)
    |> deserialize(:AvailabilityDate, :date, nil, options)
    |> deserialize(:CancellationDate, :date, nil, options)
    |> deserialize(:CloseDate, :date, nil, options)
    |> deserialize(:ContingentDate, :date, nil, options)
    |> deserialize(:ContractStatusChangeDate, :date, nil, options)
    |> deserialize(:ExpirationDate, :date, nil, options)
    |> deserialize(:LandLeaseExpirationDate, :date, nil, options)
    |> deserialize(:LeaseExpiration, :date, nil, options)
    |> deserialize(:ListingContractDate, :date, nil, options)
    |> deserialize(:OffMarketDate, :date, nil, options)
    |> deserialize(:OnMarketDate, :date, nil, options)
    |> deserialize(:PurchaseContractDate, :date, nil, options)
    |> deserialize(:WithdrawnDate, :date, nil, options)
    |> deserialize(:DocumentsChangeTimestamp, :date, nil, options)
    |> deserialize(:MajorChangeTimestamp, :date, nil, options)
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OffMarketTimestamp, :date, nil, options)
    |> deserialize(:OnMarketTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:PendingTimestamp, :date, nil, options)
    |> deserialize(:PhotosChangeTimestamp, :date, nil, options)
    |> deserialize(:PriceChangeTimestamp, :date, nil, options)
    |> deserialize(:ShowingEndTime, :date, nil, options)
    |> deserialize(:ShowingStartTime, :date, nil, options)
    |> deserialize(:StatusChangeTimestamp, :date, nil, options)
    |> deserialize(:VideosChangeTimestamp, :date, nil, options)
    |> deserialize(:BuyerAgent, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:CoBuyerAgent, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:CoListAgent, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:ListAgent, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:BuyerOffice, :struct, FoyerAPI.Model.Office, options)
    |> deserialize(:CoBuyerOffice, :struct, FoyerAPI.Model.Office, options)
    |> deserialize(:CoListOffice, :struct, FoyerAPI.Model.Office, options)
    |> deserialize(:ListOffice, :struct, FoyerAPI.Model.Office, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ListTeam, :struct, FoyerAPI.Model.Teams, options)
    |> deserialize(:BuyerTeam, :struct, FoyerAPI.Model.Teams, options)
    |> deserialize(:ContactListings, :list, FoyerAPI.Model.ContactListings, options)
    |> deserialize(:Favorites, :list, FoyerAPI.Model.Favorite, options)
    |> deserialize(:OpenHouse, :list, FoyerAPI.Model.OpenHouse, options)
    |> deserialize(:GreenBuildingVerifications, :list, FoyerAPI.Model.PropertyGreenVerification, options)
    |> deserialize(:PowerProductions, :list, FoyerAPI.Model.PropertyPowerProduction, options)
    |> deserialize(:Rooms, :list, FoyerAPI.Model.PropertyRooms, options)
    |> deserialize(:UnitTypes, :list, FoyerAPI.Model.PropertyUnitTypes, options)
    |> deserialize(:Shares, :list, FoyerAPI.Model.Share, options)
    |> deserialize(:Showings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:Transactions, :list, FoyerAPI.Model.Transaction, options)
    |> deserialize(:Media, :list, FoyerAPI.Model.Media, options)
  end
end

